//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/text_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializeclassicText")
inline fun classicText(block: gg.dsepractice.chinese.v1alpha1.ClassicTextKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ClassicText =
  gg.dsepractice.chinese.v1alpha1.ClassicTextKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.ClassicText.newBuilder()).apply { block() }._build()
object ClassicTextKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.ClassicText.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.ClassicText.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.ClassicText = _builder.build()

    /**
     * <code>string name = 1 [json_name = "name"];</code>
     */
    var name: kotlin.String
      @JvmName("getName")
      get() = _builder.getName()
      @JvmName("setName")
      set(value) {
        _builder.setName(value)
      }
    /**
     * <code>string name = 1 [json_name = "name"];</code>
     */
    fun clearName() {
      _builder.clearName()
    }

    /**
     * An uninstantiable, behaviorless type to represent the field in
     * generics.
     */
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    class AllTextSegmentsProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
    /**
     * <code>repeated string all_text_segments = 2 [json_name = "allTextSegments"];</code>
     * @return A list containing the allTextSegments.
     */
     val allTextSegments: com.google.protobuf.kotlin.DslList<kotlin.String, AllTextSegmentsProxy>
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
      get() = com.google.protobuf.kotlin.DslList(
        _builder.getAllTextSegmentsList()
      )
    /**
     * <code>repeated string all_text_segments = 2 [json_name = "allTextSegments"];</code>
     * @param value The allTextSegments to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllTextSegments")
    fun com.google.protobuf.kotlin.DslList<kotlin.String, AllTextSegmentsProxy>.add(value: kotlin.String) {
      _builder.addAllTextSegments(value)
    }
    /**
     * <code>repeated string all_text_segments = 2 [json_name = "allTextSegments"];</code>
     * @param value The allTextSegments to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllTextSegments")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<kotlin.String, AllTextSegmentsProxy>.plusAssign(value: kotlin.String) {
      add(value)
    }
    /**
     * <code>repeated string all_text_segments = 2 [json_name = "allTextSegments"];</code>
     * @param values The allTextSegments to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllAllTextSegments")
    fun com.google.protobuf.kotlin.DslList<kotlin.String, AllTextSegmentsProxy>.addAll(values: kotlin.collections.Iterable<kotlin.String>) {
      _builder.addAllAllTextSegments(values)
    }
    /**
     * <code>repeated string all_text_segments = 2 [json_name = "allTextSegments"];</code>
     * @param values The allTextSegments to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllAllTextSegments")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<kotlin.String, AllTextSegmentsProxy>.plusAssign(values: kotlin.collections.Iterable<kotlin.String>) {
      addAll(values)
    }
    /**
     * <code>repeated string all_text_segments = 2 [json_name = "allTextSegments"];</code>
     * @param index The index to set the value at.
     * @param value The allTextSegments to set.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("setAllTextSegments")
    operator fun com.google.protobuf.kotlin.DslList<kotlin.String, AllTextSegmentsProxy>.set(index: kotlin.Int, value: kotlin.String) {
      _builder.setAllTextSegments(index, value)
    }/**
     * <code>repeated string all_text_segments = 2 [json_name = "allTextSegments"];</code>
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("clearAllTextSegments")
    fun com.google.protobuf.kotlin.DslList<kotlin.String, AllTextSegmentsProxy>.clear() {
      _builder.clearAllTextSegments()
    }
    /**
     * An uninstantiable, behaviorless type to represent the field in
     * generics.
     */
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    class AllWordsProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
    /**
     * <code>repeated string all_words = 3 [json_name = "allWords"];</code>
     * @return A list containing the allWords.
     */
     val allWords: com.google.protobuf.kotlin.DslList<kotlin.String, AllWordsProxy>
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
      get() = com.google.protobuf.kotlin.DslList(
        _builder.getAllWordsList()
      )
    /**
     * <code>repeated string all_words = 3 [json_name = "allWords"];</code>
     * @param value The allWords to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllWords")
    fun com.google.protobuf.kotlin.DslList<kotlin.String, AllWordsProxy>.add(value: kotlin.String) {
      _builder.addAllWords(value)
    }
    /**
     * <code>repeated string all_words = 3 [json_name = "allWords"];</code>
     * @param value The allWords to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllWords")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<kotlin.String, AllWordsProxy>.plusAssign(value: kotlin.String) {
      add(value)
    }
    /**
     * <code>repeated string all_words = 3 [json_name = "allWords"];</code>
     * @param values The allWords to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllAllWords")
    fun com.google.protobuf.kotlin.DslList<kotlin.String, AllWordsProxy>.addAll(values: kotlin.collections.Iterable<kotlin.String>) {
      _builder.addAllAllWords(values)
    }
    /**
     * <code>repeated string all_words = 3 [json_name = "allWords"];</code>
     * @param values The allWords to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllAllWords")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<kotlin.String, AllWordsProxy>.plusAssign(values: kotlin.collections.Iterable<kotlin.String>) {
      addAll(values)
    }
    /**
     * <code>repeated string all_words = 3 [json_name = "allWords"];</code>
     * @param index The index to set the value at.
     * @param value The allWords to set.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("setAllWords")
    operator fun com.google.protobuf.kotlin.DslList<kotlin.String, AllWordsProxy>.set(index: kotlin.Int, value: kotlin.String) {
      _builder.setAllWords(index, value)
    }/**
     * <code>repeated string all_words = 3 [json_name = "allWords"];</code>
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("clearAllWords")
    fun com.google.protobuf.kotlin.DslList<kotlin.String, AllWordsProxy>.clear() {
      _builder.clearAllWords()
    }
    /**
     * An uninstantiable, behaviorless type to represent the field in
     * generics.
     */
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    class NodesProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.ParagraphNode nodes = 4 [json_name = "nodes"];</code>
     */
     val nodes: com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.ParagraphNode, NodesProxy>
      @kotlin.jvm.JvmSynthetic
      get() = com.google.protobuf.kotlin.DslList(
        _builder.getNodesList()
      )
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.ParagraphNode nodes = 4 [json_name = "nodes"];</code>
     * @param value The nodes to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addNodes")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.ParagraphNode, NodesProxy>.add(value: gg.dsepractice.chinese.v1alpha1.ParagraphNode) {
      _builder.addNodes(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.ParagraphNode nodes = 4 [json_name = "nodes"];</code>
     * @param value The nodes to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignNodes")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.ParagraphNode, NodesProxy>.plusAssign(value: gg.dsepractice.chinese.v1alpha1.ParagraphNode) {
      add(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.ParagraphNode nodes = 4 [json_name = "nodes"];</code>
     * @param values The nodes to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllNodes")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.ParagraphNode, NodesProxy>.addAll(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.ParagraphNode>) {
      _builder.addAllNodes(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.ParagraphNode nodes = 4 [json_name = "nodes"];</code>
     * @param values The nodes to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllNodes")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.ParagraphNode, NodesProxy>.plusAssign(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.ParagraphNode>) {
      addAll(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.ParagraphNode nodes = 4 [json_name = "nodes"];</code>
     * @param index The index to set the value at.
     * @param value The nodes to set.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("setNodes")
    operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.ParagraphNode, NodesProxy>.set(index: kotlin.Int, value: gg.dsepractice.chinese.v1alpha1.ParagraphNode) {
      _builder.setNodes(index, value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.ParagraphNode nodes = 4 [json_name = "nodes"];</code>
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("clearNodes")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.ParagraphNode, NodesProxy>.clear() {
      _builder.clearNodes()
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.ClassicText.copy(block: gg.dsepractice.chinese.v1alpha1.ClassicTextKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ClassicText =
  gg.dsepractice.chinese.v1alpha1.ClassicTextKt.Dsl._create(this.toBuilder()).apply { block() }._build()

